Attribute VB_Name = "Shell_Functions"
' ------------------------------------------------------------------------
'      Copyright  1997 Microsoft Corporation.  All rights reserved.
'
' You have a royalty-free right to use, modify, reproduce and distribute
' the Sample Application Files (and/or any modified version) in any way
' you find useful, provided that you agree that Microsoft has no warranty,
' obligations or liability for any Sample Application Files.
' ------------------------------------------------------------------------
Option Explicit
'----------------------------------------------------------
'- Shell Extension Public Variable...
'----------------------------------------------------------
Public hBitmap(5) As Long

Public DebugFile As String
Public DebugText As String
Public pOldFunction As Long
Private Const ProgID = "pIContextMenu.ShellExt"

Public Const clng_CommandRegister As Long = 0
Public Const clng_CommandUnRegister As Long = 1

Public Const clng_ResOffSet_Action As Long = 101
Public Const clng_ResOffSet_Help As Long = 111
Public Const clng_ResOffSet_Validate As Long = 121
'------------------------------------------------------------
Sub Main()
'------------------------------------------------------------
    Dim ClassId As String
'------------------------------------------------------------
    ' WARNING: Never remove this line of code...
    ' HACK: oleaut32 is loaded(redundantly) to prevent it from unloading
    ' inside of explorer, a bug in oleaut32.dll, ole32.dll cause data corruption
    ' and a crash if oleaut32 is loaded, unloaded and reloaded.
    LoadLibrary "oleaut32.dll"
    '------------------------------------------------------------
    
    GetClassId ProgID, ClassId
    WriteLog "ClassID: " & ClassId & " " & Format$(Now) & " Sub main ()"
'------------------------------------------------------------
End Sub
'------------------------------------------------------------

'------------------------------------------------------------
Public Function ReplaceVtableEntry(pObj As Long, EntryNumber As Integer, ByVal lpfn As Long) As Long
'------------------------------------------------------------
    Dim lOldAddr As Long
    Dim lpVtableHead As Long
    Dim lpfnAddr As Long
    Dim lOldProtect As Long
'------------------------------------------------------------
    CopyMemory lpVtableHead, ByVal pObj, 4
    lpfnAddr = lpVtableHead + (EntryNumber - 1) * 4
    CopyMemory lOldAddr, ByVal lpfnAddr, 4
    
    Call VirtualProtect(lpfnAddr, 4, PAGE_EXECUTE_READWRITE, lOldProtect)
    CopyMemory ByVal lpfnAddr, lpfn, 4
    Call VirtualProtect(lpfnAddr, 4, lOldProtect, lOldProtect)
    
    ReplaceVtableEntry = lOldAddr
'------------------------------------------------------------
End Function
'------------------------------------------------------------

'------------------------------------------------------------
Private Sub GetClassId(ByVal ProgID As String, ClassId As String)
'------------------------------------------------------------
    Dim rc As Long
    Dim IdLen As Integer
    Dim rClsId As uGUID
    Dim sProgId As String
    Dim bClassId() As Byte
'------------------------------------------------------------
    sProgId = StrConv(ProgID, vbUnicode)
    rc = CLSIDFromProgID(sProgId, rClsId)
    
    If (rc < 0) Then
        ClassId = "Bad ProgId rc::" & Str$(rc)
        Exit Sub
    End If

    IdLen = 40
    bClassId = String$(IdLen, 0)
    rc = StringFromGUID2(rClsId, VarPtr(bClassId(0)), IdLen)
    
    If (rc <= 0) Then
        ClassId = "Bad ClassID rc::" & Str$(rc)
        Exit Sub
    End If
    ClassId = bClassId

    If (Asc(Mid$(ClassId, rc, 1)) = 0) Then rc = rc - 1
    ClassId = Left$(ClassId, rc)
'------------------------------------------------------------
End Sub
'------------------------------------------------------------

'------------------------------------------------------------
Public Sub WriteLog(Line As String)
'------------------------------------------------------------
#If DebugOn Then
    Dim FileNum As Long
'------------------------------------------------------------
    If (DebugFile = "") Then
        DebugFile = App.Path
        If (Right(DebugFile, 1) <> "\") Then DebugFile = DebugFile & "\"
        DebugFile = DebugFile & "Debug.Log"
    End If
    
    FileNum = FreeFile
    Open DebugFile For Append As #FileNum
    Write #FileNum, Line
    Close #FileNum
#End If
'------------------------------------------------------------
End Sub
'------------------------------------------------------------

'------------------------------------------------------------
Public Function sc_QueryContextMenu(ByVal This As IContextMenu, ByVal hMenu As Long, ByVal indexMenu As Long, ByVal idCmdFirst As Long, ByVal idCmdLast As Long, ByVal uFlags As Long) As Long
'------------------------------------------------------------
    Dim SE As ShellExt
    Dim rc As Long
    Dim idCmd As Long
    Dim szMenu As String
    Dim szMenuText As String    ' [64]
    Dim szMenuText2 As String   ' [64]
    Dim szMenuText3 As String   ' [64]
    Dim bAppendItems As Boolean
    Dim szTemp As String        ' [32]
    Dim bBitmap() As Byte
    'Dim hBitmap As Long
    'Dim mnuPict As StdPicture
    Dim mnuPict As Picture
    
    Const CHK_BMP1 = 101&
    Const CHK_BMP2 = 102&
    Const CHK_BMP3 = 103&
    Const MENU_BMP1 = 104&
    Const MENU_BMP2 = 105&
    Const MENU_BMP3 = 105&
'------------------------------------------------------------
WriteLog "sc_QueryContextMenu:: " & vbCrLf & _
         "    hMenu:: " & CStr(hMenu) & _
            " indexMenu:: " & CStr(indexMenu) & _
            " idCmdFirst:: " & CStr(idCmdFirst) & _
            " idCmdLast:: " & CStr(idCmdLast) & _
            " uFlags:: " & CStr(uFlags)
            
    idCmd = idCmdFirst
    bAppendItems = True

    If ((uFlags And &HF&) = CMF_NORMAL) Then     ' Check == here, since CMF_NORMAL=0
        szMenuText = " &" & LoadResString(clng_CommandRegister + clng_ResOffSet_Action)
        szMenuText2 = " &" & LoadResString(clng_CommandUnRegister + clng_ResOffSet_Action)
    ElseIf ((uFlags And CMF_VERBSONLY) = CMF_VERBSONLY) Then
        szMenuText = " &" & LoadResString(clng_CommandRegister + clng_ResOffSet_Action)
        szMenuText2 = " &" & LoadResString(clng_CommandUnRegister + clng_ResOffSet_Action)

    ElseIf ((uFlags And CMF_EXPLORE) = CMF_EXPLORE) Then
        szMenuText = " &" & LoadResString(clng_CommandRegister + clng_ResOffSet_Action)
        szMenuText2 = " &" & LoadResString(clng_CommandUnRegister + clng_ResOffSet_Action)

    ElseIf ((uFlags And CMF_DEFAULTONLY) = CMF_DEFAULTONLY) Then
        bAppendItems = False
    Else
        bAppendItems = False
    End If
    
    If bAppendItems Then
#If BITMAP_MENUS Then
        '=======================================================================
        ' Insert 1st Menu...
        '=======================================================================
        ' Add bitmap...
        Set mnuPict = LoadResPicture(MENU_BMP1, vbResBitmap)
        hBitmap(0) = CopyBMP(mnuPict.Handle)
        Set mnuPict = Nothing
        Call InsertMenuBmp(hMenu, indexMenu, MF_USECHECKBITMAPS Or MF_BITMAP Or MF_BYPOSITION, idCmd, hBitmap(0))
        
        ' Add checked bitmap...
        Set mnuPict = LoadResPicture("IDB_REGISTER", vbResBitmap)
        hBitmap(1) = ScaleBMP(mnuPict.Handle)
        Set mnuPict = Nothing
        Call SetMenuItemBitmaps(hMenu, indexMenu, MF_USECHECKBITMAPS Or MF_BITMAP Or MF_BYPOSITION, hBitmap(1), hBitmap(1))

        ' Increment Index and menu count...
        indexMenu = indexMenu + 1
        idCmd = idCmd + 1
        
        '=======================================================================
        ' Insert 2nd Menu...
        '=======================================================================
        ' Add bitmap...
        Set mnuPict = LoadResPicture(MENU_BMP2, vbResBitmap)
        hBitmap(2) = CopyBMP(mnuPict.Handle)
        Set mnuPict = Nothing
        Call InsertMenuBmp(hMenu, indexMenu, MF_USECHECKBITMAPS Or MF_BITMAP Or MF_BYPOSITION, idCmd, hBitmap(2))
        
        ' Add checked bitmap...
        Set mnuPict = LoadResPicture("IDB_UNREGISTER", vbResBitmap)
        hBitmap(3) = ScaleBMP(mnuPict.Handle)
        Set mnuPict = Nothing
        Call SetMenuItemBitmaps(hMenu, indexMenu, MF_USECHECKBITMAPS Or MF_BITMAP Or MF_BYPOSITION, hBitmap(3), hBitmap(3))

        ' Increment Index and menu count...
        indexMenu = indexMenu + 1
        idCmd = idCmd + 1
        
#Else
        '=======================================================================
        ' Insert 1st Menu...
        '=======================================================================
        Call InsertMenu(hMenu, indexMenu, MF_USECHECKBITMAPS Or MF_STRING Or MF_BYPOSITION, idCmd, szMenuText)
        
        ' Add checked bitmap...
        Set mnuPict = LoadResPicture("IDB_REGISTER", vbResBitmap)
        hBitmap(0) = ScaleBMP(mnuPict.Handle)
        Set mnuPict = Nothing
        Call SetMenuItemBitmaps(hMenu, indexMenu, MF_USECHECKBITMAPS Or MF_BITMAP Or MF_BYPOSITION, hBitmap(0), hBitmap(0))

        ' Increment Index and menu count...
        indexMenu = indexMenu + 1
        idCmd = idCmd + 1
        
        '=======================================================================
        ' Insert 2nd Menu...
        '=======================================================================
        Call InsertMenu(hMenu, indexMenu, MF_USECHECKBITMAPS Or MF_STRING Or MF_BYPOSITION, idCmd, szMenuText2)
        
        ' Add checked bitmap...
        Set mnuPict = LoadResPicture("IDB_UNREGISTER", vbResBitmap)
        hBitmap(1) = ScaleBMP(mnuPict.Handle)
        Set mnuPict = Nothing
        Call SetMenuItemBitmaps(hMenu, indexMenu, MF_USECHECKBITMAPS Or MF_BITMAP Or MF_BYPOSITION, hBitmap(1), hBitmap(1))

        ' Increment Index and menu count...
        indexMenu = indexMenu + 1
        idCmd = idCmd + 1
        
        
#End If
        '=======================================================================
        ' Insert Menu Separator...
        '=======================================================================
        Call InsertMenu(hMenu, indexMenu, MF_SEPARATOR Or MF_BYPOSITION, 0, vbNullString)
        indexMenu = indexMenu + 1
        
        sc_QueryContextMenu = (idCmd - idCmdFirst)      ' Must return number of menu items inserted
    Else
        sc_QueryContextMenu = 0                         ' Must return number of menu items inserted
    End If
'------------------------------------------------------------
End Function
'------------------------------------------------------------

'------------------------------------------------------------
Public Function ScaleBMP(hBitmap1 As Long) As Long
'------------------------------------------------------------
    Dim hdc As Long
    Dim hBitmap2 As Long
    Dim tm As TEXTMETRIC
    Dim bm1 As BITMAP, bm2 As BITMAP
    Dim hdcMem1 As Long, hdcMem2 As Long
    Dim hBmOld1 As Long, hBmOld2 As Long
'------------------------------------------------------------
    hdc = CreateIC("DISPLAY", vbNullChar, vbNullChar, vbNullChar)
    Call GetTextMetrics(hdc, tm)
    
    hdcMem1 = CreateCompatibleDC(hdc)
    hdcMem2 = CreateCompatibleDC(hdc)
    DeleteDC hdc
  
    GetObject hBitmap1, LenB(bm1), bm1
  
    LSet bm2 = bm1
    
    bm2.bmWidth = tm.tmMaxCharWidth
    bm2.bmHeight = tm.tmHeight
    
    bm2.bmWidthBytes = (((bm2.bmWidth * bm2.bmBitsPixel) + 15) \ 16) * 2
  
    hBitmap2 = CreateBitmapIndirect(bm2)
  
    hBmOld1 = SelectObject(hdcMem1, hBitmap1)
    hBmOld2 = SelectObject(hdcMem2, hBitmap2)
  
    Call StretchBlt(hdcMem2, 0, 0, bm2.bmWidth, bm2.bmHeight, _
                    hdcMem1, 0, 0, bm1.bmWidth, bm1.bmHeight, vbSrcCopy)
  
    SelectObject hdcMem1, hBmOld1
    SelectObject hdcMem2, hBmOld2
    DeleteDC hdcMem1
    DeleteDC hdcMem2

    ScaleBMP = hBitmap2
'------------------------------------------------------------
End Function
'------------------------------------------------------------

'------------------------------------------------------------
Public Function CopyBMP(hBitmap1 As Long) As Long
'------------------------------------------------------------
    Dim hdc As Long
    Dim hBitmap2 As Long
    Dim bm1 As BITMAP, bm2 As BITMAP
    Dim hdcMem1 As Long, hdcMem2 As Long
    Dim hBmOld1 As Long, hBmOld2 As Long
'------------------------------------------------------------
    hdc = CreateIC("DISPLAY", vbNullChar, vbNullChar, vbNullChar)
    
    hdcMem1 = CreateCompatibleDC(hdc)
    hdcMem2 = CreateCompatibleDC(hdc)
    DeleteDC hdc
  
    GetObject hBitmap1, LenB(bm1), bm1
  
    LSet bm2 = bm1
    hBitmap2 = CreateBitmapIndirect(bm2)
  
    hBmOld1 = SelectObject(hdcMem1, hBitmap1)
    hBmOld2 = SelectObject(hdcMem2, hBitmap2)
  
    Call StretchBlt(hdcMem2, 0, 0, bm2.bmWidth, bm2.bmHeight, _
                    hdcMem1, 0, 0, bm1.bmWidth, bm1.bmHeight, vbSrcCopy)
  
    SelectObject hdcMem1, hBmOld1
    SelectObject hdcMem2, hBmOld2
    DeleteDC hdcMem1
    DeleteDC hdcMem2

    CopyBMP = hBitmap2
'------------------------------------------------------------
End Function
'------------------------------------------------------------


