VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
END
Attribute VB_Name = "ShellExt"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
' ------------------------------------------------------------------------
'      Copyright  1997 Microsoft Corporation.  All rights reserved.
'
' You have a royalty-free right to use, modify, reproduce and distribute
' the Sample Application Files (and/or any modified version) in any way
' you find useful, provided that you agree that Microsoft has no warranty,
' obligations or liability for any Sample Application Files.
' ------------------------------------------------------------------------
Option Explicit
Public m_szFile As String

'------------------------------------------------------------
'- Implemented Interfaces...
'------------------------------------------------------------
Implements IContextMenu
Implements IShellExtInit



'------------------------------------------------------------
Private Sub Class_Initialize()
'------------------------------------------------------------
    Dim pImp As Long
    Dim oImp As IContextMenu
'------------------------------------------------------------
    WriteLog "Class_Initialize:: " & vbCrLf
    
    Set oImp = Me
    Call CopyMemory(pImp, oImp, 4)
    pOldFunction = ReplaceVtableEntry(pImp, 4, AddressOf sc_QueryContextMenu)
'------------------------------------------------------------
End Sub
'------------------------------------------------------------

'------------------------------------------------------------
Private Sub Class_Terminate()
'------------------------------------------------------------
    Dim pImp As Long
    Dim oImp As IContextMenu
'------------------------------------------------------------
    WriteLog "Class_Terminate:: " & vbCrLf
    
    Set oImp = Me
    Call CopyMemory(pImp, oImp, 4)
    pOldFunction = ReplaceVtableEntry(pImp, 4, pOldFunction)
    
    DeleteObject hBitmap(0)
    DeleteObject hBitmap(1)
    DeleteObject hBitmap(2)
#If BITMAP_MENUS Then
    DeleteObject hBitmap(3)
    DeleteObject hBitmap(4)
    DeleteObject hBitmap(5)
#End If
'------------------------------------------------------------
End Sub
'------------------------------------------------------------

'------------------------------------------------------------
Private Sub IShellExtInit_Initialize(ByVal pidlFolder As Long, ByVal lpdobj As Long, ByVal hKeyProgID As Long)
'------------------------------------------------------------
    Dim strVal As String
    Dim strSize As Long
    Dim varType As Long
    Dim pIDataObj As IUnknown
    Dim oIDataObj As IDataObject
    Dim FmtEtc As FORMATETC
    Dim pMedium As STGMEDIUM
    Dim szTemp As String
    Dim szTemp2 As String
    Dim iFile As Long
    Dim iFiles As Long
    Dim rc As Long
'------------------------------------------------------------
    WriteLog "IShellExtInit_Initialize:: " & vbCrLf & _
             "    pidlFolder:: " & CStr(pidlFolder) & _
                    " lpdobj:: " & CStr(lpdobj) & _
                " hKeyProgID:: " & CStr(hKeyProgID)
    '------------------------------------------------------------
    ' Get ptr to IDataObject and determine what file(s) where
    ' Right-Clicked on inside of explorer...
    '------------------------------------------------------------
    CopyMemory pIDataObj, lpdobj, 4         ' Copy dataobject pointer to IUnknown variable
                                            ' WARNING: This does not addref the actual object.
    Set oIDataObj = pIDataObj               ' Make IDataObject Variable QueryInterface from IUnknown
    CopyMemory pIDataObj, 0&, 4             ' Set IUnknown Variable to nothing with calling release.
                                            ' Setting PIDataObj = Nothing will trash Explorer...
    With FmtEtc
        .cfFormat = CF_HDROP
        .ptd = 0
        .dwAspect = DVASPECT_CONTENT
        .lindex = -1
        .tymed = TYMED_HGLOBAL
    End With
    
    oIDataObj.GetData ByVal VarPtr(FmtEtc), ByVal VarPtr(pMedium)
    rc = Err.LastDllError
    WriteLog "oIDataObj.GetData ByVal VarPtr(FmtEtc), ByVal VarPtr(pMedium)"
    WriteLog "Err.LastDllError" & CStr(rc)
        
    iFiles = DragQueryFile(pMedium.hGlobal, &HFFFFFFFF, vbNullString, 0)
    For iFile = 0 To (iFiles - 1)
        szTemp = String(500, 0)
        rc = DragQueryFile(pMedium.hGlobal, iFile, szTemp, Len(szTemp))
        If (rc > 0) Then
            szTemp = Left$(szTemp, rc)
            WriteLog "  szTemp:: " & szTemp
            
            szTemp2 = String(500, 0)
            rc = GetShortPathNameA(szTemp, szTemp2, 500)
            If (rc > 0) Then                                ' Is char. count of ShortPathName is > 0?
                szTemp2 = Left$(szTemp2, rc)
                WriteLog "  szTemp2:: " & szTemp2
                m_szFile = m_szFile & " " & szTemp2
            End If
        End If
    Next
    
    rc = ReleaseStgMedium(pMedium)
    Set oIDataObj = Nothing
    
    '-------------------------------------------------------------------
    ' Get registry info from hKeyProgID
    '-------------------------------------------------------------------
    strSize = 512                                           ' Variable Size
    strVal = String$(strSize, 0)                            ' Allocate Variable Space
    varType = REG_SZ
    
    rc = RegQueryValueEx(hKeyProgID, vbNullString, 0&, varType, strVal, strSize)

    If (Asc(Mid(strVal, strSize, 1)) = 0) Then strSize = strSize - 1
    If ((rc = 0) And (strSize > 0)) Then
        strVal = Left(strVal, strSize)
        WriteLog "    Value= " & strVal
    End If
'------------------------------------------------------------
End Sub
'------------------------------------------------------------

'------------------------------------------------------------
Private Sub IContextMenu_QueryContextMenu(ByVal hMenu As Long, ByVal indexMenu As Long, ByVal idCmdFirst As Long, ByVal idCmdLast As Long, ByVal uFlags As Long)
'------------------------------------------------------------
' This sub has been replaced in the IContextMenu VTable with SC_QueryContextMenu
' This sub is used as a stub in the Class_Initialize Event
'------------------------------------------------------------
End Sub
'------------------------------------------------------------

'------------------------------------------------------------
Private Sub IContextMenu_GetCommandString(ByVal idCmd As Long, ByVal uFlags As Long, ByVal pwReserved As Long, ByVal pszName As Long, ByVal cchMax As Long)
'------------------------------------------------------------
' referencing pwReserved will cause a GPF, it is a null pointer.
'------------------------------------------------------------
    Dim bszName() As Byte
    Dim cChars As Long
    Dim szName As String
    Dim temp As String
'------------------------------------------------------------
    WriteLog "IContextMenu_GetCommandString" & vbCrLf & _
             "     idCmd:: " & CStr(idCmd) & _
                " uFlags:: " & CStr(uFlags) & _
               " pszName:: " & CStr(pszName) & _
                " cchMax:: " & CStr(cchMax)
    
    Select Case uFlags
        Case GCS_VERBA, GCS_VERBW
            szName = LoadResString(idCmd + clng_ResOffSet_Action) ' The Action
        Case GCS_HELPTEXTA, GCS_HELPTEXTW
            szName = LoadResString(idCmd + clng_ResOffSet_Help) ' The Help String
        Case GCS_VALIDATEA, GCS_VALIDATEW
            szName = LoadResString(idCmd + clng_ResOffSet_Validate)
    End Select
    
    ' Assign the Out String
    szName = Left$(szName, cchMax) & vbNullChar
    MsgBox "szName"
    
    Select Case uFlags
    Case GCS_VERBA, GCS_HELPTEXTA, GCS_VALIDATEA
        If (szName <> "") Then
            bszName = StrConv(szName, vbFromUnicode)
            Call CopyMemory(ByVal pszName, bszName(0), UBound(bszName) + 1)
        End If
    Case GCS_VERBW, GCS_HELPTEXTW, GCS_VALIDATEW
        If (szName <> "") Then
            bszName = szName
            Call CopyMemory(ByVal pszName, bszName(0), UBound(bszName) + 1)
        End If
    End Select
'------------------------------------------------------------
End Sub
'------------------------------------------------------------

'------------------------------------------------------------
Private Sub IContextMenu_InvokeCommand(ByVal lpcmi As Long)
'------------------------------------------------------------
    Dim idCmd As Long
    Dim CMI As CMINVOKECOMMANDINFO
    Dim Directory As String
    Dim Parameters As String
    Dim Verb As String
    Dim sLen As Long
'------------------------------------------------------------
    WriteLog "IContextMenu_InvokeCommand:: " & vbCrLf & _
             "    lpcmi:: " & CStr(lpcmi)
    
    CopyMemory CMI, ByVal lpcmi, Len(CMI)
    
    WriteLog "CMI:: " & vbCrLf & _
             "    cbSize:: " & CStr(CMI.cbSize) & vbCrLf & _
             "    dwHotKey:: " & CStr(CMI.dwHotKey) & vbCrLf & _
             "    fMask:: " & CStr(CMI.fMask) & vbCrLf & _
             "    hIcon:: " & CStr(CMI.hIcon) & vbCrLf & _
             "    hwnd:: " & CStr(CMI.hwnd) & vbCrLf & _
             "    lpDirectory:: " & CStr(CMI.lpDirectory) & vbCrLf & _
             "    lpParameters:: " & CStr(CMI.lpParameters) & vbCrLf & _
             "    lpVerb:: " & CStr(CMI.lpVerb) & vbCrLf & _
             "    nShow:: " & CStr(CMI.nShow)
    
    Directory = String(lstrlen(ByVal CMI.lpDirectory), Chr$(0))
    lstrcpy ByVal Directory, ByVal CMI.lpDirectory
    WriteLog "Directory:: " & Directory
    
    Parameters = String(lstrlen(ByVal CMI.lpParameters), Chr$(0))
    
    sLen = lstrlen(ByVal CMI.lpParameters)
    If (sLen > 0) Then
        Dim bData() As Byte
        ReDim bData(sLen) As Byte
        
        WriteLog "Len Parameters:: " & CStr(sLen)
        CopyMemory bData(0), ByVal CMI.lpParameters, sLen
        WriteLog "CopyMemory Parameters:: " & StrConv(bData, vbUnicode)
    End If
    
    lstrcpy ByVal Parameters, ByVal CMI.lpParameters
    WriteLog "Parameters:: " & Parameters
    
    ' If the high-order word of lpcmi->lpVerb is not NULL, this
    ' function was called by an application and lpVerb is a command
    ' that should be activated. Otherwise, the shell has called this
    ' function, and the low-order word of lpcmi->lpVerb is the
    ' identifier of the menu item that the user selected.
    If ((CMI.lpVerb And &HFFFF000) = 0) Then
        idCmd = CMI.lpVerb
        
        Select Case idCmd
        Case clng_CommandRegister              ' MenuItem 0 selected...
            WriteLog "idCmd:: " & CStr(idCmd)
            Shell "regsvr32.exe " & m_szFile, vbNormalFocus
        Case clng_CommandUnRegister              ' MenuItem 1 selected...
            WriteLog "idCmd:: " & CStr(idCmd)
            Shell "regsvr32.exe /U" & m_szFile, vbNormalFocus
        End Select
    Else
        Verb = String(lstrlen(ByVal CMI.lpVerb), Chr$(0))
        lstrcpy ByVal Verb, ByVal CMI.lpVerb
        WriteLog "Verb:: " & Verb
    End If
'------------------------------------------------------------
End Sub
'------------------------------------------------------------
